package ahas_openapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyIsolationRule invokes the ahas_openapi.ModifyIsolationRule API synchronously
func (client *Client) ModifyIsolationRule(request *ModifyIsolationRuleRequest) (response *ModifyIsolationRuleResponse, err error) {
	response = CreateModifyIsolationRuleResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyIsolationRuleWithChan invokes the ahas_openapi.ModifyIsolationRule API asynchronously
func (client *Client) ModifyIsolationRuleWithChan(request *ModifyIsolationRuleRequest) (<-chan *ModifyIsolationRuleResponse, <-chan error) {
	responseChan := make(chan *ModifyIsolationRuleResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyIsolationRule(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyIsolationRuleWithCallback invokes the ahas_openapi.ModifyIsolationRule API asynchronously
func (client *Client) ModifyIsolationRuleWithCallback(request *ModifyIsolationRuleRequest, callback func(response *ModifyIsolationRuleResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyIsolationRuleResponse
		var err error
		defer close(result)
		response, err = client.ModifyIsolationRule(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyIsolationRuleRequest is the request struct for api ModifyIsolationRule
type ModifyIsolationRuleRequest struct {
	*requests.RpcRequest
	RefResource      string           `position:"Query" name:"RefResource"`
	Threshold        requests.Float   `position:"Query" name:"Threshold"`
	AhasRegionId     string           `position:"Query" name:"AhasRegionId"`
	LimitOrigin      string           `position:"Query" name:"LimitOrigin"`
	RelationStrategy requests.Integer `position:"Query" name:"RelationStrategy"`
	RuleId           requests.Integer `position:"Query" name:"RuleId"`
}

// ModifyIsolationRuleResponse is the response struct for api ModifyIsolationRule
type ModifyIsolationRuleResponse struct {
	*responses.BaseResponse
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Code      string `json:"Code" xml:"Code"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateModifyIsolationRuleRequest creates a request to invoke ModifyIsolationRule API
func CreateModifyIsolationRuleRequest() (request *ModifyIsolationRuleRequest) {
	request = &ModifyIsolationRuleRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ahas-openapi", "2019-09-01", "ModifyIsolationRule", "ahas", "openAPI")
	request.Method = requests.POST
	return
}

// CreateModifyIsolationRuleResponse creates a response to parse from ModifyIsolationRule response
func CreateModifyIsolationRuleResponse() (response *ModifyIsolationRuleResponse) {
	response = &ModifyIsolationRuleResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
