package cloudesl

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// BatchUpdateEvent invokes the cloudesl.BatchUpdateEvent API synchronously
func (client *Client) BatchUpdateEvent(request *BatchUpdateEventRequest) (response *BatchUpdateEventResponse, err error) {
	response = CreateBatchUpdateEventResponse()
	err = client.DoAction(request, response)
	return
}

// BatchUpdateEventWithChan invokes the cloudesl.BatchUpdateEvent API asynchronously
func (client *Client) BatchUpdateEventWithChan(request *BatchUpdateEventRequest) (<-chan *BatchUpdateEventResponse, <-chan error) {
	responseChan := make(chan *BatchUpdateEventResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.BatchUpdateEvent(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// BatchUpdateEventWithCallback invokes the cloudesl.BatchUpdateEvent API asynchronously
func (client *Client) BatchUpdateEventWithCallback(request *BatchUpdateEventRequest, callback func(response *BatchUpdateEventResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *BatchUpdateEventResponse
		var err error
		defer close(result)
		response, err = client.BatchUpdateEvent(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// BatchUpdateEventRequest is the request struct for api BatchUpdateEvent
type BatchUpdateEventRequest struct {
	*requests.RpcRequest
	Events string `position:"Body" name:"Events"`
}

// BatchUpdateEventResponse is the response struct for api BatchUpdateEvent
type BatchUpdateEventResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	ErrorMessage   string `json:"ErrorMessage" xml:"ErrorMessage"`
	Success        bool   `json:"Success" xml:"Success"`
	ErrorCode      string `json:"ErrorCode" xml:"ErrorCode"`
	Code           string `json:"Code" xml:"Code"`
	Message        string `json:"Message" xml:"Message"`
	DynamicMessage string `json:"DynamicMessage" xml:"DynamicMessage"`
	DynamicCode    string `json:"DynamicCode" xml:"DynamicCode"`
}

// CreateBatchUpdateEventRequest creates a request to invoke BatchUpdateEvent API
func CreateBatchUpdateEventRequest() (request *BatchUpdateEventRequest) {
	request = &BatchUpdateEventRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudesl", "2020-02-01", "BatchUpdateEvent", "", "")
	request.Method = requests.POST
	return
}

// CreateBatchUpdateEventResponse creates a response to parse from BatchUpdateEvent response
func CreateBatchUpdateEventResponse() (response *BatchUpdateEventResponse) {
	response = &BatchUpdateEventResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
