package dataworks_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListEntityTags invokes the dataworks_public.ListEntityTags API synchronously
func (client *Client) ListEntityTags(request *ListEntityTagsRequest) (response *ListEntityTagsResponse, err error) {
	response = CreateListEntityTagsResponse()
	err = client.DoAction(request, response)
	return
}

// ListEntityTagsWithChan invokes the dataworks_public.ListEntityTags API asynchronously
func (client *Client) ListEntityTagsWithChan(request *ListEntityTagsRequest) (<-chan *ListEntityTagsResponse, <-chan error) {
	responseChan := make(chan *ListEntityTagsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListEntityTags(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListEntityTagsWithCallback invokes the dataworks_public.ListEntityTags API asynchronously
func (client *Client) ListEntityTagsWithCallback(request *ListEntityTagsRequest, callback func(response *ListEntityTagsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListEntityTagsResponse
		var err error
		defer close(result)
		response, err = client.ListEntityTags(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListEntityTagsRequest is the request struct for api ListEntityTags
type ListEntityTagsRequest struct {
	*requests.RpcRequest
	QualifiedName string `position:"Query" name:"QualifiedName"`
}

// ListEntityTagsResponse is the response struct for api ListEntityTags
type ListEntityTagsResponse struct {
	*responses.BaseResponse
	RequestId      string   `json:"RequestId" xml:"RequestId"`
	Success        bool     `json:"Success" xml:"Success"`
	ErrorCode      string   `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMessage   string   `json:"ErrorMessage" xml:"ErrorMessage"`
	HttpStatusCode int      `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Data           []string `json:"Data" xml:"Data"`
}

// CreateListEntityTagsRequest creates a request to invoke ListEntityTags API
func CreateListEntityTagsRequest() (request *ListEntityTagsRequest) {
	request = &ListEntityTagsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dataworks-public", "2020-05-18", "ListEntityTags", "", "")
	request.Method = requests.GET
	return
}

// CreateListEntityTagsResponse creates a response to parse from ListEntityTags response
func CreateListEntityTagsResponse() (response *ListEntityTagsResponse) {
	response = &ListEntityTagsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
