package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateFixedPriceSelectedOrder invokes the domain.CreateFixedPriceSelectedOrder API synchronously
func (client *Client) CreateFixedPriceSelectedOrder(request *CreateFixedPriceSelectedOrderRequest) (response *CreateFixedPriceSelectedOrderResponse, err error) {
	response = CreateCreateFixedPriceSelectedOrderResponse()
	err = client.DoAction(request, response)
	return
}

// CreateFixedPriceSelectedOrderWithChan invokes the domain.CreateFixedPriceSelectedOrder API asynchronously
func (client *Client) CreateFixedPriceSelectedOrderWithChan(request *CreateFixedPriceSelectedOrderRequest) (<-chan *CreateFixedPriceSelectedOrderResponse, <-chan error) {
	responseChan := make(chan *CreateFixedPriceSelectedOrderResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateFixedPriceSelectedOrder(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateFixedPriceSelectedOrderWithCallback invokes the domain.CreateFixedPriceSelectedOrder API asynchronously
func (client *Client) CreateFixedPriceSelectedOrderWithCallback(request *CreateFixedPriceSelectedOrderRequest, callback func(response *CreateFixedPriceSelectedOrderResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateFixedPriceSelectedOrderResponse
		var err error
		defer close(result)
		response, err = client.CreateFixedPriceSelectedOrder(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateFixedPriceSelectedOrderRequest is the request struct for api CreateFixedPriceSelectedOrder
type CreateFixedPriceSelectedOrderRequest struct {
	*requests.RpcRequest
	Code          string `position:"Query" name:"Code"`
	ContactId     string `position:"Query" name:"ContactId"`
	ExpectedPrice string `position:"Query" name:"ExpectedPrice"`
	DomainName    string `position:"Query" name:"DomainName"`
	Source        string `position:"Query" name:"Source"`
}

// CreateFixedPriceSelectedOrderResponse is the response struct for api CreateFixedPriceSelectedOrder
type CreateFixedPriceSelectedOrderResponse struct {
	*responses.BaseResponse
	RequestId      string                                `json:"RequestId" xml:"RequestId"`
	HttpStatusCode int                                   `json:"HttpStatusCode" xml:"HttpStatusCode"`
	ErrorCode      string                                `json:"ErrorCode" xml:"ErrorCode"`
	Success        bool                                  `json:"Success" xml:"Success"`
	Module         ModuleInCreateFixedPriceSelectedOrder `json:"Module" xml:"Module"`
}

// CreateCreateFixedPriceSelectedOrderRequest creates a request to invoke CreateFixedPriceSelectedOrder API
func CreateCreateFixedPriceSelectedOrderRequest() (request *CreateFixedPriceSelectedOrderRequest) {
	request = &CreateFixedPriceSelectedOrderRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2018-02-08", "CreateFixedPriceSelectedOrder", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateFixedPriceSelectedOrderResponse creates a response to parse from CreateFixedPriceSelectedOrder response
func CreateCreateFixedPriceSelectedOrderResponse() (response *CreateFixedPriceSelectedOrderResponse) {
	response = &CreateFixedPriceSelectedOrderResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
