package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryBatchTaskDetailList invokes the domain.QueryBatchTaskDetailList API synchronously
func (client *Client) QueryBatchTaskDetailList(request *QueryBatchTaskDetailListRequest) (response *QueryBatchTaskDetailListResponse, err error) {
	response = CreateQueryBatchTaskDetailListResponse()
	err = client.DoAction(request, response)
	return
}

// QueryBatchTaskDetailListWithChan invokes the domain.QueryBatchTaskDetailList API asynchronously
func (client *Client) QueryBatchTaskDetailListWithChan(request *QueryBatchTaskDetailListRequest) (<-chan *QueryBatchTaskDetailListResponse, <-chan error) {
	responseChan := make(chan *QueryBatchTaskDetailListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryBatchTaskDetailList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryBatchTaskDetailListWithCallback invokes the domain.QueryBatchTaskDetailList API asynchronously
func (client *Client) QueryBatchTaskDetailListWithCallback(request *QueryBatchTaskDetailListRequest, callback func(response *QueryBatchTaskDetailListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryBatchTaskDetailListResponse
		var err error
		defer close(result)
		response, err = client.QueryBatchTaskDetailList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryBatchTaskDetailListRequest is the request struct for api QueryBatchTaskDetailList
type QueryBatchTaskDetailListRequest struct {
	*requests.RpcRequest
	SaleId       string           `position:"Query" name:"SaleId"`
	DomainName   string           `position:"Query" name:"DomainName"`
	PageNum      requests.Integer `position:"Query" name:"PageNum"`
	TaskStatus   requests.Integer `position:"Query" name:"TaskStatus"`
	UserClientIp string           `position:"Query" name:"UserClientIp"`
	TaskNo       string           `position:"Query" name:"TaskNo"`
	PageSize     requests.Integer `position:"Query" name:"PageSize"`
	Lang         string           `position:"Query" name:"Lang"`
}

// QueryBatchTaskDetailListResponse is the response struct for api QueryBatchTaskDetailList
type QueryBatchTaskDetailListResponse struct {
	*responses.BaseResponse
	PrePage        bool                           `json:"PrePage" xml:"PrePage"`
	CurrentPageNum int                            `json:"CurrentPageNum" xml:"CurrentPageNum"`
	RequestId      string                         `json:"RequestId" xml:"RequestId"`
	PageSize       int                            `json:"PageSize" xml:"PageSize"`
	TotalPageNum   int                            `json:"TotalPageNum" xml:"TotalPageNum"`
	TotalItemNum   int                            `json:"TotalItemNum" xml:"TotalItemNum"`
	NextPage       bool                           `json:"NextPage" xml:"NextPage"`
	Data           DataInQueryBatchTaskDetailList `json:"Data" xml:"Data"`
}

// CreateQueryBatchTaskDetailListRequest creates a request to invoke QueryBatchTaskDetailList API
func CreateQueryBatchTaskDetailListRequest() (request *QueryBatchTaskDetailListRequest) {
	request = &QueryBatchTaskDetailListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2016-05-11", "QueryBatchTaskDetailList", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryBatchTaskDetailListResponse creates a response to parse from QueryBatchTaskDetailList response
func CreateQueryBatchTaskDetailListResponse() (response *QueryBatchTaskDetailListResponse) {
	response = &QueryBatchTaskDetailListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
