package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SaveTaskForModifyingDomainDns invokes the domain.SaveTaskForModifyingDomainDns API synchronously
func (client *Client) SaveTaskForModifyingDomainDns(request *SaveTaskForModifyingDomainDnsRequest) (response *SaveTaskForModifyingDomainDnsResponse, err error) {
	response = CreateSaveTaskForModifyingDomainDnsResponse()
	err = client.DoAction(request, response)
	return
}

// SaveTaskForModifyingDomainDnsWithChan invokes the domain.SaveTaskForModifyingDomainDns API asynchronously
func (client *Client) SaveTaskForModifyingDomainDnsWithChan(request *SaveTaskForModifyingDomainDnsRequest) (<-chan *SaveTaskForModifyingDomainDnsResponse, <-chan error) {
	responseChan := make(chan *SaveTaskForModifyingDomainDnsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SaveTaskForModifyingDomainDns(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SaveTaskForModifyingDomainDnsWithCallback invokes the domain.SaveTaskForModifyingDomainDns API asynchronously
func (client *Client) SaveTaskForModifyingDomainDnsWithCallback(request *SaveTaskForModifyingDomainDnsRequest, callback func(response *SaveTaskForModifyingDomainDnsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SaveTaskForModifyingDomainDnsResponse
		var err error
		defer close(result)
		response, err = client.SaveTaskForModifyingDomainDns(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SaveTaskForModifyingDomainDnsRequest is the request struct for api SaveTaskForModifyingDomainDns
type SaveTaskForModifyingDomainDnsRequest struct {
	*requests.RpcRequest
	SaleId       string           `position:"Query" name:"SaleId"`
	DomainName   string           `position:"Query" name:"DomainName"`
	AliyunDns    requests.Boolean `position:"Query" name:"AliyunDns"`
	DnsList      *[]string        `position:"Query" name:"DnsList"  type:"Repeated"`
	UserClientIp string           `position:"Query" name:"UserClientIp"`
	Lang         string           `position:"Query" name:"Lang"`
}

// SaveTaskForModifyingDomainDnsResponse is the response struct for api SaveTaskForModifyingDomainDns
type SaveTaskForModifyingDomainDnsResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	TaskNo    string `json:"TaskNo" xml:"TaskNo"`
}

// CreateSaveTaskForModifyingDomainDnsRequest creates a request to invoke SaveTaskForModifyingDomainDns API
func CreateSaveTaskForModifyingDomainDnsRequest() (request *SaveTaskForModifyingDomainDnsRequest) {
	request = &SaveTaskForModifyingDomainDnsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2016-05-11", "SaveTaskForModifyingDomainDns", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSaveTaskForModifyingDomainDnsResponse creates a response to parse from SaveTaskForModifyingDomainDns response
func CreateSaveTaskForModifyingDomainDnsResponse() (response *SaveTaskForModifyingDomainDnsResponse) {
	response = &SaveTaskForModifyingDomainDnsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
