package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SelectedDomainList invokes the domain.SelectedDomainList API synchronously
func (client *Client) SelectedDomainList(request *SelectedDomainListRequest) (response *SelectedDomainListResponse, err error) {
	response = CreateSelectedDomainListResponse()
	err = client.DoAction(request, response)
	return
}

// SelectedDomainListWithChan invokes the domain.SelectedDomainList API asynchronously
func (client *Client) SelectedDomainListWithChan(request *SelectedDomainListRequest) (<-chan *SelectedDomainListResponse, <-chan error) {
	responseChan := make(chan *SelectedDomainListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SelectedDomainList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SelectedDomainListWithCallback invokes the domain.SelectedDomainList API asynchronously
func (client *Client) SelectedDomainListWithCallback(request *SelectedDomainListRequest, callback func(response *SelectedDomainListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SelectedDomainListResponse
		var err error
		defer close(result)
		response, err = client.SelectedDomainList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SelectedDomainListRequest is the request struct for api SelectedDomainList
type SelectedDomainListRequest struct {
	*requests.RpcRequest
	ListDate string `position:"Query" name:"ListDate"`
}

// SelectedDomainListResponse is the response struct for api SelectedDomainList
type SelectedDomainListResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	ErrorCode string `json:"ErrorCode" xml:"ErrorCode"`
	Module    Module `json:"Module" xml:"Module"`
}

// CreateSelectedDomainListRequest creates a request to invoke SelectedDomainList API
func CreateSelectedDomainListRequest() (request *SelectedDomainListRequest) {
	request = &SelectedDomainListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2018-02-08", "SelectedDomainList", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSelectedDomainListResponse creates a response to parse from SelectedDomainList response
func CreateSelectedDomainListResponse() (response *SelectedDomainListResponse) {
	response = &SelectedDomainListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
