package ens

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// TerminateWorkflow invokes the ens.TerminateWorkflow API synchronously
func (client *Client) TerminateWorkflow(request *TerminateWorkflowRequest) (response *TerminateWorkflowResponse, err error) {
	response = CreateTerminateWorkflowResponse()
	err = client.DoAction(request, response)
	return
}

// TerminateWorkflowWithChan invokes the ens.TerminateWorkflow API asynchronously
func (client *Client) TerminateWorkflowWithChan(request *TerminateWorkflowRequest) (<-chan *TerminateWorkflowResponse, <-chan error) {
	responseChan := make(chan *TerminateWorkflowResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.TerminateWorkflow(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// TerminateWorkflowWithCallback invokes the ens.TerminateWorkflow API asynchronously
func (client *Client) TerminateWorkflowWithCallback(request *TerminateWorkflowRequest, callback func(response *TerminateWorkflowResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *TerminateWorkflowResponse
		var err error
		defer close(result)
		response, err = client.TerminateWorkflow(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// TerminateWorkflowRequest is the request struct for api TerminateWorkflow
type TerminateWorkflowRequest struct {
	*requests.RpcRequest
	WorkflowIds *[]string `position:"Query" name:"WorkflowIds"  type:"Json"`
}

// TerminateWorkflowResponse is the response struct for api TerminateWorkflow
type TerminateWorkflowResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateTerminateWorkflowRequest creates a request to invoke TerminateWorkflow API
func CreateTerminateWorkflowRequest() (request *TerminateWorkflowRequest) {
	request = &TerminateWorkflowRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ens", "2017-11-10", "TerminateWorkflow", "ens", "openAPI")
	request.Method = requests.POST
	return
}

// CreateTerminateWorkflowResponse creates a response to parse from TerminateWorkflow response
func CreateTerminateWorkflowResponse() (response *TerminateWorkflowResponse) {
	response = &TerminateWorkflowResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
