package gpdb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// PauseInstance invokes the gpdb.PauseInstance API synchronously
func (client *Client) PauseInstance(request *PauseInstanceRequest) (response *PauseInstanceResponse, err error) {
	response = CreatePauseInstanceResponse()
	err = client.DoAction(request, response)
	return
}

// PauseInstanceWithChan invokes the gpdb.PauseInstance API asynchronously
func (client *Client) PauseInstanceWithChan(request *PauseInstanceRequest) (<-chan *PauseInstanceResponse, <-chan error) {
	responseChan := make(chan *PauseInstanceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.PauseInstance(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// PauseInstanceWithCallback invokes the gpdb.PauseInstance API asynchronously
func (client *Client) PauseInstanceWithCallback(request *PauseInstanceRequest, callback func(response *PauseInstanceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *PauseInstanceResponse
		var err error
		defer close(result)
		response, err = client.PauseInstance(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// PauseInstanceRequest is the request struct for api PauseInstance
type PauseInstanceRequest struct {
	*requests.RpcRequest
	DBInstanceId string           `position:"Query" name:"DBInstanceId"`
	OwnerId      requests.Integer `position:"Query" name:"OwnerId"`
}

// PauseInstanceResponse is the response struct for api PauseInstance
type PauseInstanceResponse struct {
	*responses.BaseResponse
	RequestId    string `json:"RequestId" xml:"RequestId"`
	Status       bool   `json:"Status" xml:"Status"`
	ErrorMessage string `json:"ErrorMessage" xml:"ErrorMessage"`
	DBInstanceId string `json:"DBInstanceId" xml:"DBInstanceId"`
}

// CreatePauseInstanceRequest creates a request to invoke PauseInstance API
func CreatePauseInstanceRequest() (request *PauseInstanceRequest) {
	request = &PauseInstanceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("gpdb", "2016-05-03", "PauseInstance", "", "")
	request.Method = requests.POST
	return
}

// CreatePauseInstanceResponse creates a response to parse from PauseInstance response
func CreatePauseInstanceResponse() (response *PauseInstanceResponse) {
	response = &PauseInstanceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
