package linkvisual

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AddRecordPlanDevice invokes the linkvisual.AddRecordPlanDevice API synchronously
func (client *Client) AddRecordPlanDevice(request *AddRecordPlanDeviceRequest) (response *AddRecordPlanDeviceResponse, err error) {
	response = CreateAddRecordPlanDeviceResponse()
	err = client.DoAction(request, response)
	return
}

// AddRecordPlanDeviceWithChan invokes the linkvisual.AddRecordPlanDevice API asynchronously
func (client *Client) AddRecordPlanDeviceWithChan(request *AddRecordPlanDeviceRequest) (<-chan *AddRecordPlanDeviceResponse, <-chan error) {
	responseChan := make(chan *AddRecordPlanDeviceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AddRecordPlanDevice(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AddRecordPlanDeviceWithCallback invokes the linkvisual.AddRecordPlanDevice API asynchronously
func (client *Client) AddRecordPlanDeviceWithCallback(request *AddRecordPlanDeviceRequest, callback func(response *AddRecordPlanDeviceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AddRecordPlanDeviceResponse
		var err error
		defer close(result)
		response, err = client.AddRecordPlanDevice(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AddRecordPlanDeviceRequest is the request struct for api AddRecordPlanDevice
type AddRecordPlanDeviceRequest struct {
	*requests.RpcRequest
	IotId         string           `position:"Query" name:"IotId"`
	IotInstanceId string           `position:"Query" name:"IotInstanceId"`
	StreamType    requests.Integer `position:"Query" name:"StreamType"`
	ProductKey    string           `position:"Query" name:"ProductKey"`
	ApiProduct    string           `position:"Body" name:"ApiProduct"`
	ApiRevision   string           `position:"Body" name:"ApiRevision"`
	DeviceName    string           `position:"Query" name:"DeviceName"`
	PlanId        string           `position:"Query" name:"PlanId"`
}

// AddRecordPlanDeviceResponse is the response struct for api AddRecordPlanDevice
type AddRecordPlanDeviceResponse struct {
	*responses.BaseResponse
	Code         string `json:"Code" xml:"Code"`
	RequestId    string `json:"RequestId" xml:"RequestId"`
	ErrorMessage string `json:"ErrorMessage" xml:"ErrorMessage"`
	Success      bool   `json:"Success" xml:"Success"`
}

// CreateAddRecordPlanDeviceRequest creates a request to invoke AddRecordPlanDevice API
func CreateAddRecordPlanDeviceRequest() (request *AddRecordPlanDeviceRequest) {
	request = &AddRecordPlanDeviceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Linkvisual", "2018-01-20", "AddRecordPlanDevice", "Linkvisual", "openAPI")
	request.Method = requests.POST
	return
}

// CreateAddRecordPlanDeviceResponse creates a response to parse from AddRecordPlanDevice response
func CreateAddRecordPlanDeviceResponse() (response *AddRecordPlanDeviceResponse) {
	response = &AddRecordPlanDeviceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
