package linkvisual

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryEventRecordPlanDetail invokes the linkvisual.QueryEventRecordPlanDetail API synchronously
func (client *Client) QueryEventRecordPlanDetail(request *QueryEventRecordPlanDetailRequest) (response *QueryEventRecordPlanDetailResponse, err error) {
	response = CreateQueryEventRecordPlanDetailResponse()
	err = client.DoAction(request, response)
	return
}

// QueryEventRecordPlanDetailWithChan invokes the linkvisual.QueryEventRecordPlanDetail API asynchronously
func (client *Client) QueryEventRecordPlanDetailWithChan(request *QueryEventRecordPlanDetailRequest) (<-chan *QueryEventRecordPlanDetailResponse, <-chan error) {
	responseChan := make(chan *QueryEventRecordPlanDetailResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryEventRecordPlanDetail(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryEventRecordPlanDetailWithCallback invokes the linkvisual.QueryEventRecordPlanDetail API asynchronously
func (client *Client) QueryEventRecordPlanDetailWithCallback(request *QueryEventRecordPlanDetailRequest, callback func(response *QueryEventRecordPlanDetailResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryEventRecordPlanDetailResponse
		var err error
		defer close(result)
		response, err = client.QueryEventRecordPlanDetail(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryEventRecordPlanDetailRequest is the request struct for api QueryEventRecordPlanDetail
type QueryEventRecordPlanDetailRequest struct {
	*requests.RpcRequest
	ApiProduct  string `position:"Body" name:"ApiProduct"`
	ApiRevision string `position:"Body" name:"ApiRevision"`
	PlanId      string `position:"Query" name:"PlanId"`
}

// QueryEventRecordPlanDetailResponse is the response struct for api QueryEventRecordPlanDetail
type QueryEventRecordPlanDetailResponse struct {
	*responses.BaseResponse
	Code         string `json:"Code" xml:"Code"`
	RequestId    string `json:"RequestId" xml:"RequestId"`
	ErrorMessage string `json:"ErrorMessage" xml:"ErrorMessage"`
	Success      bool   `json:"Success" xml:"Success"`
	Data         Data   `json:"Data" xml:"Data"`
}

// CreateQueryEventRecordPlanDetailRequest creates a request to invoke QueryEventRecordPlanDetail API
func CreateQueryEventRecordPlanDetailRequest() (request *QueryEventRecordPlanDetailRequest) {
	request = &QueryEventRecordPlanDetailRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Linkvisual", "2018-01-20", "QueryEventRecordPlanDetail", "Linkvisual", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryEventRecordPlanDetailResponse creates a response to parse from QueryEventRecordPlanDetail response
func CreateQueryEventRecordPlanDetailResponse() (response *QueryEventRecordPlanDetailResponse) {
	response = &QueryEventRecordPlanDetailResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
