package linkvisual

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryFaceUserIdByCustomUserId invokes the linkvisual.QueryFaceUserIdByCustomUserId API synchronously
func (client *Client) QueryFaceUserIdByCustomUserId(request *QueryFaceUserIdByCustomUserIdRequest) (response *QueryFaceUserIdByCustomUserIdResponse, err error) {
	response = CreateQueryFaceUserIdByCustomUserIdResponse()
	err = client.DoAction(request, response)
	return
}

// QueryFaceUserIdByCustomUserIdWithChan invokes the linkvisual.QueryFaceUserIdByCustomUserId API asynchronously
func (client *Client) QueryFaceUserIdByCustomUserIdWithChan(request *QueryFaceUserIdByCustomUserIdRequest) (<-chan *QueryFaceUserIdByCustomUserIdResponse, <-chan error) {
	responseChan := make(chan *QueryFaceUserIdByCustomUserIdResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryFaceUserIdByCustomUserId(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryFaceUserIdByCustomUserIdWithCallback invokes the linkvisual.QueryFaceUserIdByCustomUserId API asynchronously
func (client *Client) QueryFaceUserIdByCustomUserIdWithCallback(request *QueryFaceUserIdByCustomUserIdRequest, callback func(response *QueryFaceUserIdByCustomUserIdResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryFaceUserIdByCustomUserIdResponse
		var err error
		defer close(result)
		response, err = client.QueryFaceUserIdByCustomUserId(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryFaceUserIdByCustomUserIdRequest is the request struct for api QueryFaceUserIdByCustomUserId
type QueryFaceUserIdByCustomUserIdRequest struct {
	*requests.RpcRequest
	IsolationId  string `position:"Query" name:"IsolationId"`
	CustomUserId string `position:"Query" name:"CustomUserId"`
	ApiProduct   string `position:"Body" name:"ApiProduct"`
	ApiRevision  string `position:"Body" name:"ApiRevision"`
}

// QueryFaceUserIdByCustomUserIdResponse is the response struct for api QueryFaceUserIdByCustomUserId
type QueryFaceUserIdByCustomUserIdResponse struct {
	*responses.BaseResponse
	Code         string `json:"Code" xml:"Code"`
	RequestId    string `json:"RequestId" xml:"RequestId"`
	ErrorMessage string `json:"ErrorMessage" xml:"ErrorMessage"`
	Success      bool   `json:"Success" xml:"Success"`
	Data         Data   `json:"Data" xml:"Data"`
}

// CreateQueryFaceUserIdByCustomUserIdRequest creates a request to invoke QueryFaceUserIdByCustomUserId API
func CreateQueryFaceUserIdByCustomUserIdRequest() (request *QueryFaceUserIdByCustomUserIdRequest) {
	request = &QueryFaceUserIdByCustomUserIdRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Linkvisual", "2018-01-20", "QueryFaceUserIdByCustomUserId", "Linkvisual", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryFaceUserIdByCustomUserIdResponse creates a response to parse from QueryFaceUserIdByCustomUserId response
func CreateQueryFaceUserIdByCustomUserIdResponse() (response *QueryFaceUserIdByCustomUserIdResponse) {
	response = &QueryFaceUserIdByCustomUserIdResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
