package mpaas

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// OpenApiDecode invokes the mpaas.OpenApiDecode API synchronously
func (client *Client) OpenApiDecode(request *OpenApiDecodeRequest) (response *OpenApiDecodeResponse, err error) {
	response = CreateOpenApiDecodeResponse()
	err = client.DoAction(request, response)
	return
}

// OpenApiDecodeWithChan invokes the mpaas.OpenApiDecode API asynchronously
func (client *Client) OpenApiDecodeWithChan(request *OpenApiDecodeRequest) (<-chan *OpenApiDecodeResponse, <-chan error) {
	responseChan := make(chan *OpenApiDecodeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.OpenApiDecode(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// OpenApiDecodeWithCallback invokes the mpaas.OpenApiDecode API asynchronously
func (client *Client) OpenApiDecodeWithCallback(request *OpenApiDecodeRequest, callback func(response *OpenApiDecodeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *OpenApiDecodeResponse
		var err error
		defer close(result)
		response, err = client.OpenApiDecode(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// OpenApiDecodeRequest is the request struct for api OpenApiDecode
type OpenApiDecodeRequest struct {
	*requests.RpcRequest
	TenantId                             string `position:"Body" name:"TenantId"`
	MpaasMqcpOpenApiDecodeRequestJsonStr string `position:"Body" name:"MpaasMqcpOpenApiDecodeRequestJsonStr"`
	AppId                                string `position:"Body" name:"AppId"`
	WorkspaceId                          string `position:"Body" name:"WorkspaceId"`
}

// OpenApiDecodeResponse is the response struct for api OpenApiDecode
type OpenApiDecodeResponse struct {
	*responses.BaseResponse
	ResultContent string `json:"ResultContent" xml:"ResultContent"`
	ResultCode    string `json:"ResultCode" xml:"ResultCode"`
	RequestId     string `json:"RequestId" xml:"RequestId"`
}

// CreateOpenApiDecodeRequest creates a request to invoke OpenApiDecode API
func CreateOpenApiDecodeRequest() (request *OpenApiDecodeRequest) {
	request = &OpenApiDecodeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("mPaaS", "2020-10-28", "OpenApiDecode", "", "")
	request.Method = requests.POST
	return
}

// CreateOpenApiDecodeResponse creates a response to parse from OpenApiDecode response
func CreateOpenApiDecodeResponse() (response *OpenApiDecodeResponse) {
	response = &OpenApiDecodeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
