package paifeaturestore

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// WriteProjectFeatureEntityHotIds invokes the paifeaturestore.WriteProjectFeatureEntityHotIds API synchronously
func (client *Client) WriteProjectFeatureEntityHotIds(request *WriteProjectFeatureEntityHotIdsRequest) (response *WriteProjectFeatureEntityHotIdsResponse, err error) {
	response = CreateWriteProjectFeatureEntityHotIdsResponse()
	err = client.DoAction(request, response)
	return
}

// WriteProjectFeatureEntityHotIdsWithChan invokes the paifeaturestore.WriteProjectFeatureEntityHotIds API asynchronously
func (client *Client) WriteProjectFeatureEntityHotIdsWithChan(request *WriteProjectFeatureEntityHotIdsRequest) (<-chan *WriteProjectFeatureEntityHotIdsResponse, <-chan error) {
	responseChan := make(chan *WriteProjectFeatureEntityHotIdsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.WriteProjectFeatureEntityHotIds(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// WriteProjectFeatureEntityHotIdsWithCallback invokes the paifeaturestore.WriteProjectFeatureEntityHotIds API asynchronously
func (client *Client) WriteProjectFeatureEntityHotIdsWithCallback(request *WriteProjectFeatureEntityHotIdsRequest, callback func(response *WriteProjectFeatureEntityHotIdsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *WriteProjectFeatureEntityHotIdsResponse
		var err error
		defer close(result)
		response, err = client.WriteProjectFeatureEntityHotIds(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// WriteProjectFeatureEntityHotIdsRequest is the request struct for api WriteProjectFeatureEntityHotIds
type WriteProjectFeatureEntityHotIdsRequest struct {
	*requests.RoaRequest
	Body              string `position:"Body" name:"body"`
	InstanceId        string `position:"Path" name:"InstanceId"`
	FeatureEntityName string `position:"Path" name:"FeatureEntityName"`
	ProjectId         string `position:"Path" name:"ProjectId"`
}

// WriteProjectFeatureEntityHotIdsResponse is the response struct for api WriteProjectFeatureEntityHotIds
type WriteProjectFeatureEntityHotIdsResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateWriteProjectFeatureEntityHotIdsRequest creates a request to invoke WriteProjectFeatureEntityHotIds API
func CreateWriteProjectFeatureEntityHotIdsRequest() (request *WriteProjectFeatureEntityHotIdsRequest) {
	request = &WriteProjectFeatureEntityHotIdsRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("PaiFeatureStore", "2023-06-21", "WriteProjectFeatureEntityHotIds", "/api/v1/instances/[InstanceId]/projects/[ProjectId]/featureentities/[FeatureEntityName]/action/writehotids", "", "")
	request.Method = requests.POST
	return
}

// CreateWriteProjectFeatureEntityHotIdsResponse creates a response to parse from WriteProjectFeatureEntityHotIds response
func CreateWriteProjectFeatureEntityHotIdsResponse() (response *WriteProjectFeatureEntityHotIdsResponse) {
	response = &WriteProjectFeatureEntityHotIdsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
