package pts

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreatePtsSceneBaseLineFromReport invokes the pts.CreatePtsSceneBaseLineFromReport API synchronously
func (client *Client) CreatePtsSceneBaseLineFromReport(request *CreatePtsSceneBaseLineFromReportRequest) (response *CreatePtsSceneBaseLineFromReportResponse, err error) {
	response = CreateCreatePtsSceneBaseLineFromReportResponse()
	err = client.DoAction(request, response)
	return
}

// CreatePtsSceneBaseLineFromReportWithChan invokes the pts.CreatePtsSceneBaseLineFromReport API asynchronously
func (client *Client) CreatePtsSceneBaseLineFromReportWithChan(request *CreatePtsSceneBaseLineFromReportRequest) (<-chan *CreatePtsSceneBaseLineFromReportResponse, <-chan error) {
	responseChan := make(chan *CreatePtsSceneBaseLineFromReportResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreatePtsSceneBaseLineFromReport(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreatePtsSceneBaseLineFromReportWithCallback invokes the pts.CreatePtsSceneBaseLineFromReport API asynchronously
func (client *Client) CreatePtsSceneBaseLineFromReportWithCallback(request *CreatePtsSceneBaseLineFromReportRequest, callback func(response *CreatePtsSceneBaseLineFromReportResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreatePtsSceneBaseLineFromReportResponse
		var err error
		defer close(result)
		response, err = client.CreatePtsSceneBaseLineFromReport(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreatePtsSceneBaseLineFromReportRequest is the request struct for api CreatePtsSceneBaseLineFromReport
type CreatePtsSceneBaseLineFromReportRequest struct {
	*requests.RpcRequest
	ReportId string `position:"Query" name:"ReportId"`
	SceneId  string `position:"Query" name:"SceneId"`
}

// CreatePtsSceneBaseLineFromReportResponse is the response struct for api CreatePtsSceneBaseLineFromReport
type CreatePtsSceneBaseLineFromReportResponse struct {
	*responses.BaseResponse
	Message        string `json:"Message" xml:"Message"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Code           string `json:"Code" xml:"Code"`
	Success        bool   `json:"Success" xml:"Success"`
}

// CreateCreatePtsSceneBaseLineFromReportRequest creates a request to invoke CreatePtsSceneBaseLineFromReport API
func CreateCreatePtsSceneBaseLineFromReportRequest() (request *CreatePtsSceneBaseLineFromReportRequest) {
	request = &CreatePtsSceneBaseLineFromReportRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("PTS", "2020-10-20", "CreatePtsSceneBaseLineFromReport", "", "")
	request.Method = requests.POST
	return
}

// CreateCreatePtsSceneBaseLineFromReportResponse creates a response to parse from CreatePtsSceneBaseLineFromReport response
func CreateCreatePtsSceneBaseLineFromReportResponse() (response *CreatePtsSceneBaseLineFromReportResponse) {
	response = &CreatePtsSceneBaseLineFromReportResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
