package videoenhan

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ReduceVideoNoise invokes the videoenhan.ReduceVideoNoise API synchronously
func (client *Client) ReduceVideoNoise(request *ReduceVideoNoiseRequest) (response *ReduceVideoNoiseResponse, err error) {
	response = CreateReduceVideoNoiseResponse()
	err = client.DoAction(request, response)
	return
}

// ReduceVideoNoiseWithChan invokes the videoenhan.ReduceVideoNoise API asynchronously
func (client *Client) ReduceVideoNoiseWithChan(request *ReduceVideoNoiseRequest) (<-chan *ReduceVideoNoiseResponse, <-chan error) {
	responseChan := make(chan *ReduceVideoNoiseResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ReduceVideoNoise(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ReduceVideoNoiseWithCallback invokes the videoenhan.ReduceVideoNoise API asynchronously
func (client *Client) ReduceVideoNoiseWithCallback(request *ReduceVideoNoiseRequest, callback func(response *ReduceVideoNoiseResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ReduceVideoNoiseResponse
		var err error
		defer close(result)
		response, err = client.ReduceVideoNoise(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ReduceVideoNoiseRequest is the request struct for api ReduceVideoNoise
type ReduceVideoNoiseRequest struct {
	*requests.RpcRequest
	Async    requests.Boolean `position:"Body" name:"Async"`
	VideoUrl string           `position:"Body" name:"VideoUrl"`
}

// ReduceVideoNoiseResponse is the response struct for api ReduceVideoNoise
type ReduceVideoNoiseResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateReduceVideoNoiseRequest creates a request to invoke ReduceVideoNoise API
func CreateReduceVideoNoiseRequest() (request *ReduceVideoNoiseRequest) {
	request = &ReduceVideoNoiseRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("videoenhan", "2020-03-20", "ReduceVideoNoise", "videoenhan", "openAPI")
	request.Method = requests.POST
	return
}

// CreateReduceVideoNoiseResponse creates a response to parse from ReduceVideoNoise response
func CreateReduceVideoNoiseResponse() (response *ReduceVideoNoiseResponse) {
	response = &ReduceVideoNoiseResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
